<?php

if ( !defined('K_COUCH_DIR') ) die(); // cannot be loaded directly

$FUNCS->register_tag('curl', function($params, $node){
	global $FUNCS, $CTX;

	extract($FUNCS->get_named_vars(
		array(
			'url' => '',
			'method' => '',
			'headers' => '',
			'data' => '',
			'into' => '',
			'is_json' => '',
			'scope' => ''
		), $params)
	);

	$url = trim($url);
	$method = trim($method);
	$headers = trim($headers);
	$data = trim($data);
	$into = trim($into);
	$is_json = trim($is_json);
	$scope = trim($scope);

	if (!strlen($method)) {
		$method = 'get';
	}

	if (!extension_loaded('curl')) {
		die("Error in tag '".$node->name."': curl extension not available");
	}

	if (!strlen($url)) {
		die("Error in tag '".$node->name."': url empty");
	}

	$curl_request = curl_init();
	curl_setopt($curl_request, CURLOPT_URL, $url);
	curl_setopt($curl_request, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($curl_request, CURLOPT_TIMEOUT, 20);
	if(strlen($headers)) {
		curl_setopt($curl_request, CURLOPT_HTTPHEADER, explode(" | ", $headers));
	}
	if($method == 'post') {
		curl_setopt($curl_request, CURLOPT_POST, TRUE);
	} elseif ($method == 'put') {
		curl_setopt($curl_request, CURLOPT_CUSTOMREQUEST, "PUT");
	} elseif ($method == 'patch') {
		curl_setopt($curl_request, CURLOPT_CUSTOMREQUEST, "PATCH");
	} elseif ($method == 'delete') {
		curl_setopt($curl_request, CURLOPT_CUSTOMREQUEST, "DELETE");
	}
	if(strlen($data)) {
		curl_setopt($curl_request, CURLOPT_POSTFIELDS, $data);
	}
	curl_setopt($ch, CURLOPT_USERAGENT, "CouchCMS " . $CTX->get('k_cms_version') );
	curl_setopt($ch, CURLOPT_REFERER, $CTX->get('k_page_link') );

	$response = curl_exec($curl_request);
	curl_close($curl_request);
	if(strlen($into)) {
		if($is_json) {
			$CTX->set($into, $FUNCS->json_decode($response), 'global');
		} elseif(strlen($scope)) {
			$CTX->set($into, $response, $scope);
		} else {
			$CTX->set($into, $response);
		}
	} else {
		return $response;
	}
});